/*
 * pp5xhw.h
 *
 * Header file for hardware-level routines used by pp5x.c.
 *
 * Revision history:
 *
 * 19-Nov-1996: V-0.0; written for public release of pp5x.c
 *
 * Copyright (C) 1996 David Tait.  All rights reserved.
 * Permission is granted to use, modify, or redistribute this software
 * so long as it is not sold or used for profit.
 *
 * THIS SOFTWARE IS PROVIDED AS IS AND WITHOUT WARRANTY OF ANY KIND,
 * EITHER EXPRESSED OR IMPLIED.
 *
 */

#ifndef __PP5XHW_H
#define __PP5XHW_H
#include "upphw.h"
#include "timer.h"
#include "hex.h"

#define OK      0
#define INVALID -1
#define NOLOOP  -2
#define BADREGS -3

#define TVDD            TICKS(25000)    /* approx 25ms */
#define TPW             TICKS(100)      /* programming pulse - 100us */
#define TREC            TICKS(10)       /* recovery time - 10us */
#define TSET            TICKS(2)        /* setup time - 2us */
#define THLD            TICKS(2)        /* hold time */
#define TCLK            TICKS(5)        /* default register clock width */

extern int one_socket;
extern int has18pins;

void idle_mode(void);
void prog_mode(void);
U16 prog_cycle(int n, U16 w);
U16 read_cycle(void);
void cleanup(void);
int setup(void);

#endif /* __PP5XHW_H */
